// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/logicmonitor/lm-sdk-go/models"
)

// AddSDTReader is a Reader for the AddSDT structure.
type AddSDTReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddSDTReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewAddSDTOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	default:
		result := NewAddSDTDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddSDTOK creates a AddSDTOK with default headers values
func NewAddSDTOK() *AddSDTOK {
	return &AddSDTOK{}
}

/*AddSDTOK handles this case with default header values.

successful operation
*/
type AddSDTOK struct {
	Payload models.SDT
}

func (o *AddSDTOK) Error() string {
	return fmt.Sprintf("[POST /sdt/sdts][%d] addSdtOK  %+v", 200, o.Payload)
}

func (o *AddSDTOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalSDT(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewAddSDTDefault creates a AddSDTDefault with default headers values
func NewAddSDTDefault(code int) *AddSDTDefault {
	return &AddSDTDefault{
		_statusCode: code,
	}
}

/*AddSDTDefault handles this case with default header values.

Error
*/
type AddSDTDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the add SDT default response
func (o *AddSDTDefault) Code() int {
	return o._statusCode
}

func (o *AddSDTDefault) Error() string {
	return fmt.Sprintf("[POST /sdt/sdts][%d] addSDT default  %+v", o._statusCode, o.Payload)
}

func (o *AddSDTDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
