// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetDevicePropertyListParams creates a new GetDevicePropertyListParams object
// with the default values initialized.
func NewGetDevicePropertyListParams() *GetDevicePropertyListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetDevicePropertyListParams{
		Offset: &offsetDefault,
		Size:   &sizeDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetDevicePropertyListParamsWithTimeout creates a new GetDevicePropertyListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetDevicePropertyListParamsWithTimeout(timeout time.Duration) *GetDevicePropertyListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetDevicePropertyListParams{
		Offset: &offsetDefault,
		Size:   &sizeDefault,

		timeout: timeout,
	}
}

// NewGetDevicePropertyListParamsWithContext creates a new GetDevicePropertyListParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetDevicePropertyListParamsWithContext(ctx context.Context) *GetDevicePropertyListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetDevicePropertyListParams{
		Offset: &offsetDefault,
		Size:   &sizeDefault,

		Context: ctx,
	}
}

// NewGetDevicePropertyListParamsWithHTTPClient creates a new GetDevicePropertyListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetDevicePropertyListParamsWithHTTPClient(client *http.Client) *GetDevicePropertyListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetDevicePropertyListParams{
		Offset:     &offsetDefault,
		Size:       &sizeDefault,
		HTTPClient: client,
	}
}

/*GetDevicePropertyListParams contains all the parameters to send to the API endpoint
for the get device property list operation typically these are written to a http.Request
*/
type GetDevicePropertyListParams struct {

	/*DeviceID*/
	DeviceID int32
	/*Fields*/
	Fields *string
	/*Filter*/
	Filter *string
	/*Offset*/
	Offset *int32
	/*Size*/
	Size *int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get device property list params
func (o *GetDevicePropertyListParams) WithTimeout(timeout time.Duration) *GetDevicePropertyListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get device property list params
func (o *GetDevicePropertyListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get device property list params
func (o *GetDevicePropertyListParams) WithContext(ctx context.Context) *GetDevicePropertyListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get device property list params
func (o *GetDevicePropertyListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get device property list params
func (o *GetDevicePropertyListParams) WithHTTPClient(client *http.Client) *GetDevicePropertyListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get device property list params
func (o *GetDevicePropertyListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDeviceID adds the deviceID to the get device property list params
func (o *GetDevicePropertyListParams) WithDeviceID(deviceID int32) *GetDevicePropertyListParams {
	o.SetDeviceID(deviceID)
	return o
}

// SetDeviceID adds the deviceId to the get device property list params
func (o *GetDevicePropertyListParams) SetDeviceID(deviceID int32) {
	o.DeviceID = deviceID
}

// WithFields adds the fields to the get device property list params
func (o *GetDevicePropertyListParams) WithFields(fields *string) *GetDevicePropertyListParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the get device property list params
func (o *GetDevicePropertyListParams) SetFields(fields *string) {
	o.Fields = fields
}

// WithFilter adds the filter to the get device property list params
func (o *GetDevicePropertyListParams) WithFilter(filter *string) *GetDevicePropertyListParams {
	o.SetFilter(filter)
	return o
}

// SetFilter adds the filter to the get device property list params
func (o *GetDevicePropertyListParams) SetFilter(filter *string) {
	o.Filter = filter
}

// WithOffset adds the offset to the get device property list params
func (o *GetDevicePropertyListParams) WithOffset(offset *int32) *GetDevicePropertyListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get device property list params
func (o *GetDevicePropertyListParams) SetOffset(offset *int32) {
	o.Offset = offset
}

// WithSize adds the size to the get device property list params
func (o *GetDevicePropertyListParams) WithSize(size *int32) *GetDevicePropertyListParams {
	o.SetSize(size)
	return o
}

// SetSize adds the size to the get device property list params
func (o *GetDevicePropertyListParams) SetSize(size *int32) {
	o.Size = size
}

// WriteToRequest writes these params to a swagger request
func (o *GetDevicePropertyListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param deviceId
	if err := r.SetPathParam("deviceId", swag.FormatInt32(o.DeviceID)); err != nil {
		return err
	}

	if o.Fields != nil {

		// query param fields
		var qrFields string
		if o.Fields != nil {
			qrFields = *o.Fields
		}
		qFields := qrFields
		if qFields != "" {
			if err := r.SetQueryParam("fields", qFields); err != nil {
				return err
			}
		}

	}

	if o.Filter != nil {

		// query param filter
		var qrFilter string
		if o.Filter != nil {
			qrFilter = *o.Filter
		}
		qFilter := qrFilter
		if qFilter != "" {
			if err := r.SetQueryParam("filter", qFilter); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int32
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt32(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.Size != nil {

		// query param size
		var qrSize int32
		if o.Size != nil {
			qrSize = *o.Size
		}
		qSize := swag.FormatInt32(qrSize)
		if qSize != "" {
			if err := r.SetQueryParam("size", qSize); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
