// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetRoleListParams creates a new GetRoleListParams object
// with the default values initialized.
func NewGetRoleListParams() *GetRoleListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetRoleListParams{
		Offset: &offsetDefault,
		Size:   &sizeDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetRoleListParamsWithTimeout creates a new GetRoleListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetRoleListParamsWithTimeout(timeout time.Duration) *GetRoleListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetRoleListParams{
		Offset: &offsetDefault,
		Size:   &sizeDefault,

		timeout: timeout,
	}
}

// NewGetRoleListParamsWithContext creates a new GetRoleListParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetRoleListParamsWithContext(ctx context.Context) *GetRoleListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetRoleListParams{
		Offset: &offsetDefault,
		Size:   &sizeDefault,

		Context: ctx,
	}
}

// NewGetRoleListParamsWithHTTPClient creates a new GetRoleListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetRoleListParamsWithHTTPClient(client *http.Client) *GetRoleListParams {
	var (
		offsetDefault = int32(0)
		sizeDefault   = int32(50)
	)
	return &GetRoleListParams{
		Offset:     &offsetDefault,
		Size:       &sizeDefault,
		HTTPClient: client,
	}
}

/*GetRoleListParams contains all the parameters to send to the API endpoint
for the get role list operation typically these are written to a http.Request
*/
type GetRoleListParams struct {

	/*Fields*/
	Fields *string
	/*Filter*/
	Filter *string
	/*Offset*/
	Offset *int32
	/*Size*/
	Size *int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get role list params
func (o *GetRoleListParams) WithTimeout(timeout time.Duration) *GetRoleListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get role list params
func (o *GetRoleListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get role list params
func (o *GetRoleListParams) WithContext(ctx context.Context) *GetRoleListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get role list params
func (o *GetRoleListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get role list params
func (o *GetRoleListParams) WithHTTPClient(client *http.Client) *GetRoleListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get role list params
func (o *GetRoleListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the get role list params
func (o *GetRoleListParams) WithFields(fields *string) *GetRoleListParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the get role list params
func (o *GetRoleListParams) SetFields(fields *string) {
	o.Fields = fields
}

// WithFilter adds the filter to the get role list params
func (o *GetRoleListParams) WithFilter(filter *string) *GetRoleListParams {
	o.SetFilter(filter)
	return o
}

// SetFilter adds the filter to the get role list params
func (o *GetRoleListParams) SetFilter(filter *string) {
	o.Filter = filter
}

// WithOffset adds the offset to the get role list params
func (o *GetRoleListParams) WithOffset(offset *int32) *GetRoleListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get role list params
func (o *GetRoleListParams) SetOffset(offset *int32) {
	o.Offset = offset
}

// WithSize adds the size to the get role list params
func (o *GetRoleListParams) WithSize(size *int32) *GetRoleListParams {
	o.SetSize(size)
	return o
}

// SetSize adds the size to the get role list params
func (o *GetRoleListParams) SetSize(size *int32) {
	o.Size = size
}

// WriteToRequest writes these params to a swagger request
func (o *GetRoleListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// query param fields
		var qrFields string
		if o.Fields != nil {
			qrFields = *o.Fields
		}
		qFields := qrFields
		if qFields != "" {
			if err := r.SetQueryParam("fields", qFields); err != nil {
				return err
			}
		}

	}

	if o.Filter != nil {

		// query param filter
		var qrFilter string
		if o.Filter != nil {
			qrFilter = *o.Filter
		}
		qFilter := qrFilter
		if qFilter != "" {
			if err := r.SetQueryParam("filter", qFilter); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int32
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt32(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.Size != nil {

		// query param size
		var qrSize int32
		if o.Size != nil {
			qrSize = *o.Size
		}
		qSize := swag.FormatInt32(qrSize)
		if qSize != "" {
			if err := r.SetQueryParam("size", qSize); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
